	#!/usr/bin/python
# -*- coding: iso8859-1 -*

#!/usr/bin/python
############################################################################
#    Copyright (C) 2006 by Cesar Kallas   	
#    cesarkallas[a]soulivre.org     - http://cesarkallas.soulivre.org
#                                                                          
#    This program is free software; you can redistribute it and#or modify  
#    it under the terms of the GNU General Public License as published by  
#    the Free Software Foundation; either version 2 of the License, or     
#    (at your option) any later version.                                   
#                                                                          
#    This program is distributed in the hope that it will be useful,       
#    but WITHOUT ANY WARRANTY; without even the implied warranty of        
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
#    GNU General Public License for more details.                          
#                                                                          
#    You should have received a copy of the GNU General Public License     
#    along with this program; if not, write to the                         
#    Free Software Foundation, Inc.,                                       
#    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             
############################################################################
#	3 Projeto - Versao Distribuida da Aplicacao usando RPC
#	Pontificia Universidade Catolica de Campinas		-	 PUC Campinas
#	Sistemas Distribuidos	-	Prof Eduardo Zagari	-	http://docentes.puc-campinas.edu.br/ceatec/zagari/
#	Aluno: Cesar Kallas	-	RA: 02099224			-	Engenharia de Computacao

import socket
import sys
import time
import math
import string
import thread
import SimpleXMLRPCServer

class Funcoes(object):
	def InversaoFrase(self, frase):
		"""
		Funcao que inverte uma frase
		Entradas:
			frase: string
		Saida:
			fraseInvertida: string com a frase de entrada invertida
			-1: para falha
		"""
		try:
			fraseInvertida = frase[::-1]
			return fraseInvertida
		except Exception:
			return "-1"
	
	
	def RaizQuadrada(self, numero):
		"""
		Funcao que calcula a raiz quadrada de um numero
		Entrada:
			numero: numero a ser calculado a raiz quadrada
		Saida:
			raiz: raiz quadrada do numero
			-1: para falha
		"""
		try:
			raiz = math.sqrt(float(numero))
			return raiz
		except Exception:
			return "-1"
	
	
	def MaximoDivisor(self, numero):
		"""
		Funcao que calcula o maximo divisor de um numero
		Entrada:
			numero: numero para ser calcula o seu maximo divisor
		Saida:
			maxDiv: maximo divisor do numero
			-1: para falha
		"""
		try:
			numero = int(numero)
			if numero <= 1:
					return numero
			maxDiv = numero
	
			for i in range(1, numero-1):
					if numero % (i) == 0:
							maxDiv = i
	
			if maxDiv == 1:
					if numero > 1:
							return numero
			return maxDiv
		except Exception:
			return "-1"


def main(porta):
	funcoes = Funcoes()
	servidorRPC = SimpleXMLRPCServer.SimpleXMLRPCServer(('', porta)	)
	servidorRPC.register_instance(funcoes)
	servidorRPC.serve_forever()


if __name__ == "__main__":
	if len(sys.argv) == 2:
		porta = sys.argv[1]
		if porta.isdigit() == True:
			main(int(porta))
			sys.exit(0)
	print "Uso: %s porta" % sys.argv[0]
